// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/direktiv/direktiv/ent/predicate"
	"github.com/direktiv/direktiv/ent/workfloweventswait"
)

// WorkflowEventsWaitDelete is the builder for deleting a WorkflowEventsWait entity.
type WorkflowEventsWaitDelete struct {
	config
	hooks    []Hook
	mutation *WorkflowEventsWaitMutation
}

// Where appends a list predicates to the WorkflowEventsWaitDelete builder.
func (wewd *WorkflowEventsWaitDelete) Where(ps ...predicate.WorkflowEventsWait) *WorkflowEventsWaitDelete {
	wewd.mutation.Where(ps...)
	return wewd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (wewd *WorkflowEventsWaitDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(wewd.hooks) == 0 {
		affected, err = wewd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*WorkflowEventsWaitMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			wewd.mutation = mutation
			affected, err = wewd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(wewd.hooks) - 1; i >= 0; i-- {
			if wewd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = wewd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, wewd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (wewd *WorkflowEventsWaitDelete) ExecX(ctx context.Context) int {
	n, err := wewd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (wewd *WorkflowEventsWaitDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: workfloweventswait.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: workfloweventswait.FieldID,
			},
		},
	}
	if ps := wewd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, wewd.driver, _spec)
}

// WorkflowEventsWaitDeleteOne is the builder for deleting a single WorkflowEventsWait entity.
type WorkflowEventsWaitDeleteOne struct {
	wewd *WorkflowEventsWaitDelete
}

// Exec executes the deletion query.
func (wewdo *WorkflowEventsWaitDeleteOne) Exec(ctx context.Context) error {
	n, err := wewdo.wewd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{workfloweventswait.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (wewdo *WorkflowEventsWaitDeleteOne) ExecX(ctx context.Context) {
	wewdo.wewd.ExecX(ctx)
}
