// Code generated by go-swagger; DO NOT EDIT.

package global_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpdateGlobalServiceParams creates a new UpdateGlobalServiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateGlobalServiceParams() *UpdateGlobalServiceParams {
	return &UpdateGlobalServiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateGlobalServiceParamsWithTimeout creates a new UpdateGlobalServiceParams object
// with the ability to set a timeout on a request.
func NewUpdateGlobalServiceParamsWithTimeout(timeout time.Duration) *UpdateGlobalServiceParams {
	return &UpdateGlobalServiceParams{
		timeout: timeout,
	}
}

// NewUpdateGlobalServiceParamsWithContext creates a new UpdateGlobalServiceParams object
// with the ability to set a context for a request.
func NewUpdateGlobalServiceParamsWithContext(ctx context.Context) *UpdateGlobalServiceParams {
	return &UpdateGlobalServiceParams{
		Context: ctx,
	}
}

// NewUpdateGlobalServiceParamsWithHTTPClient creates a new UpdateGlobalServiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateGlobalServiceParamsWithHTTPClient(client *http.Client) *UpdateGlobalServiceParams {
	return &UpdateGlobalServiceParams{
		HTTPClient: client,
	}
}

/* UpdateGlobalServiceParams contains all the parameters to send to the API endpoint
   for the update global service operation.

   Typically these are written to a http.Request.
*/
type UpdateGlobalServiceParams struct {

	/* Service.

	   Payload that contains information on service revision
	*/
	Service UpdateGlobalServiceBody

	/* ServiceName.

	   target service name
	*/
	ServiceName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update global service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGlobalServiceParams) WithDefaults() *UpdateGlobalServiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update global service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGlobalServiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update global service params
func (o *UpdateGlobalServiceParams) WithTimeout(timeout time.Duration) *UpdateGlobalServiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update global service params
func (o *UpdateGlobalServiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update global service params
func (o *UpdateGlobalServiceParams) WithContext(ctx context.Context) *UpdateGlobalServiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update global service params
func (o *UpdateGlobalServiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update global service params
func (o *UpdateGlobalServiceParams) WithHTTPClient(client *http.Client) *UpdateGlobalServiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update global service params
func (o *UpdateGlobalServiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithService adds the service to the update global service params
func (o *UpdateGlobalServiceParams) WithService(service UpdateGlobalServiceBody) *UpdateGlobalServiceParams {
	o.SetService(service)
	return o
}

// SetService adds the service to the update global service params
func (o *UpdateGlobalServiceParams) SetService(service UpdateGlobalServiceBody) {
	o.Service = service
}

// WithServiceName adds the serviceName to the update global service params
func (o *UpdateGlobalServiceParams) WithServiceName(serviceName string) *UpdateGlobalServiceParams {
	o.SetServiceName(serviceName)
	return o
}

// SetServiceName adds the serviceName to the update global service params
func (o *UpdateGlobalServiceParams) SetServiceName(serviceName string) {
	o.ServiceName = serviceName
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateGlobalServiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Service); err != nil {
		return err
	}

	// path param serviceName
	if err := r.SetPathParam("serviceName", o.ServiceName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
