// Code generated by go-swagger; DO NOT EDIT.

package metrics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWorkflowMetricsInvokedParams creates a new WorkflowMetricsInvokedParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWorkflowMetricsInvokedParams() *WorkflowMetricsInvokedParams {
	return &WorkflowMetricsInvokedParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWorkflowMetricsInvokedParamsWithTimeout creates a new WorkflowMetricsInvokedParams object
// with the ability to set a timeout on a request.
func NewWorkflowMetricsInvokedParamsWithTimeout(timeout time.Duration) *WorkflowMetricsInvokedParams {
	return &WorkflowMetricsInvokedParams{
		timeout: timeout,
	}
}

// NewWorkflowMetricsInvokedParamsWithContext creates a new WorkflowMetricsInvokedParams object
// with the ability to set a context for a request.
func NewWorkflowMetricsInvokedParamsWithContext(ctx context.Context) *WorkflowMetricsInvokedParams {
	return &WorkflowMetricsInvokedParams{
		Context: ctx,
	}
}

// NewWorkflowMetricsInvokedParamsWithHTTPClient creates a new WorkflowMetricsInvokedParams object
// with the ability to set a custom HTTPClient for a request.
func NewWorkflowMetricsInvokedParamsWithHTTPClient(client *http.Client) *WorkflowMetricsInvokedParams {
	return &WorkflowMetricsInvokedParams{
		HTTPClient: client,
	}
}

/* WorkflowMetricsInvokedParams contains all the parameters to send to the API endpoint
   for the workflow metrics invoked operation.

   Typically these are written to a http.Request.
*/
type WorkflowMetricsInvokedParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the workflow metrics invoked params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WorkflowMetricsInvokedParams) WithDefaults() *WorkflowMetricsInvokedParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the workflow metrics invoked params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WorkflowMetricsInvokedParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) WithTimeout(timeout time.Duration) *WorkflowMetricsInvokedParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) WithContext(ctx context.Context) *WorkflowMetricsInvokedParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) WithHTTPClient(client *http.Client) *WorkflowMetricsInvokedParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) WithNamespace(namespace string) *WorkflowMetricsInvokedParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithWorkflow adds the workflow to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) WithWorkflow(workflow string) *WorkflowMetricsInvokedParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the workflow metrics invoked params
func (o *WorkflowMetricsInvokedParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *WorkflowMetricsInvokedParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
