// Code generated by go-swagger; DO NOT EDIT.

package variables

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteWorkflowVariableParams creates a new DeleteWorkflowVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteWorkflowVariableParams() *DeleteWorkflowVariableParams {
	return &DeleteWorkflowVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteWorkflowVariableParamsWithTimeout creates a new DeleteWorkflowVariableParams object
// with the ability to set a timeout on a request.
func NewDeleteWorkflowVariableParamsWithTimeout(timeout time.Duration) *DeleteWorkflowVariableParams {
	return &DeleteWorkflowVariableParams{
		timeout: timeout,
	}
}

// NewDeleteWorkflowVariableParamsWithContext creates a new DeleteWorkflowVariableParams object
// with the ability to set a context for a request.
func NewDeleteWorkflowVariableParamsWithContext(ctx context.Context) *DeleteWorkflowVariableParams {
	return &DeleteWorkflowVariableParams{
		Context: ctx,
	}
}

// NewDeleteWorkflowVariableParamsWithHTTPClient creates a new DeleteWorkflowVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteWorkflowVariableParamsWithHTTPClient(client *http.Client) *DeleteWorkflowVariableParams {
	return &DeleteWorkflowVariableParams{
		HTTPClient: client,
	}
}

/* DeleteWorkflowVariableParams contains all the parameters to send to the API endpoint
   for the delete workflow variable operation.

   Typically these are written to a http.Request.
*/
type DeleteWorkflowVariableParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Var.

	   target variable
	*/
	Var string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete workflow variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteWorkflowVariableParams) WithDefaults() *DeleteWorkflowVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete workflow variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteWorkflowVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) WithTimeout(timeout time.Duration) *DeleteWorkflowVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) WithContext(ctx context.Context) *DeleteWorkflowVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) WithHTTPClient(client *http.Client) *DeleteWorkflowVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) WithNamespace(namespace string) *DeleteWorkflowVariableParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithVar adds the varVar to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) WithVar(varVar string) *DeleteWorkflowVariableParams {
	o.SetVar(varVar)
	return o
}

// SetVar adds the var to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) SetVar(varVar string) {
	o.Var = varVar
}

// WithWorkflow adds the workflow to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) WithWorkflow(workflow string) *DeleteWorkflowVariableParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the delete workflow variable params
func (o *DeleteWorkflowVariableParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteWorkflowVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// query param var
	qrVar := o.Var
	qVar := qrVar
	if qVar != "" {

		if err := r.SetQueryParam("var", qVar); err != nil {
			return err
		}
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
